Bug 2264277 - Review Request: scx_c_schedulers - sched_ext schedulers written in c
Summary: Review Request: scx_c_schedulers - sched_ext schedulers written in c
Keywords:
Status: POST
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Michel Lind
QA Contact: Fedora Extras Quality Assurance
URL: https://github.com/sched-ext/scx
Whiteboard:
: 2275018 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2024-02-14 20:56 UTC by Jordan Rome
Modified: 2024-05-07 21:17 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: ---
Embargoed:
michel: fedora-review+


Attachments (Terms of Use)
The .spec file difference from Copr build 7018090 to 7027757 (1.95 KB, patch)
2024-02-17 02:49 UTC, Fedora Review Service
no flags Details | Diff

Description Jordan Rome 2024-02-14 20:56:55 UTC
Spec URL: https://jordalgo.fedorapeople.org/review/scx_c_schedulers/scx_c_schedulers.spec
SRPM URL: https://jordalgo.fedorapeople.org/review/scx_c_schedulers/scx_c_schedulers-0.1.8-1.fc39.src.rpm

Description:
Example sched_ext schedulers written in C (as opposed to Rust) that include:
"scx_central", "scx_flatcg", "scx_nest", "scx_pair", "scx_qmap", "scx_simple", 'scx_userland'.

Fedora Account System Username: jordalgo

Comment 1 Jordan Rome 2024-02-14 20:56:58 UTC
This package built on koji:  https://koji.fedoraproject.org/koji/taskinfo?taskID=113508540

Comment 2 Fedora Review Service 2024-02-14 20:57:31 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7018084
(failed)

Build log:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2264277-scx_c_schedulers/srpm-builds/07018084/builder-live.log.gz

Please make sure the package builds successfully at least for Fedora Rawhide.

- If the build failed for unrelated reasons (e.g. temporary network
  unavailability), please ignore it.
- If the build failed because of missing BuildRequires, please make sure they
  are listed in the "Depends On" field


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 3 Jordan Rome 2024-02-14 21:05:25 UTC
[fedora-review-service-build]

Comment 4 Fedora Review Service 2024-02-14 21:08:23 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7018090
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2264277-scx_c_schedulers/fedora-rawhide-x86_64/07018090-scx_c_schedulers/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 5 Benson Muite 2024-02-15 20:26:24 UTC
The spec file lists only GPL-2.0-only license, yet there are BSD-2-clause and LGPL-2.0 licenses in
the bundled libbpf.  These should also be listed in the spec file, and ideally a license breakdown
also given.

Maybe helpful to explain in the spec file why Clang is used rather than the default GCC.

Warnings from fedora-review (spelling errors and manual page entries can be ignored):
scx_c_schedulers.aarch64: W: summary-not-capitalized sched_ext schedulers written in c
scx_c_schedulers.src: W: summary-not-capitalized sched_ext schedulers written in c
scx_c_schedulers.aarch64: E: spelling-error ('flatcg', '%description -l en_US flatcg -> flat cg, flat-cg, flatcar')
scx_c_schedulers.src: E: spelling-error ('flatcg', '%description -l en_US flatcg -> flat cg, flat-cg, flatcar')
scx_c_schedulers.src: E: spelling-error ('qmap', '%description -l en_US qmap -> map, q map')
scx_c_schedulers.src: E: spelling-error ('userland', '%description -l en_US userland -> user land, user-land, slanderous')
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_central
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_flatcg
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_nest
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_pair
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_qmap
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_simple
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_userland
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_central
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_flatcg
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_nest
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_pair
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_qmap
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_simple
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_userland
scx_c_schedulers-debugsource.aarch64: E: files-duplicated-waste 100043
scx_c_schedulers.aarch64: E: description-line-too-long "scx_central", "scx_flatcg", "scx_nest", "scx_pair", "scx_qmap", "scx
_simple", 'scx_userland'.
scx_c_schedulers.src: E: description-line-too-long "scx_central", "scx_flatcg", "scx_nest", "scx_pair", "scx_qmap", "scx_sim
ple", 'scx_userland'.
 4 packages and 0 specfiles checked; 9 errors, 16 warnings, 49 filtered, 9 badness; has taken 1.4 s

Comment 6 Jordan Rome 2024-02-16 18:41:14 UTC
[fedora-review-service-build]

Comment 7 Jordan Rome 2024-02-16 18:43:37 UTC
@benson_muite Thanks for the review!

- license details have been updated
- added a comment about clang
- fixed the description length lint error

As far as the PIE warnings go, I don't think those apply to these bpf programs, which are statically built binaries (not shared libs) but I updated the rpmlintrc to ignore these.

Comment 8 Fedora Review Service 2024-02-17 02:49:51 UTC
Created attachment 2017285 [details]
The .spec file difference from Copr build 7018090 to 7027757

Comment 9 Fedora Review Service 2024-02-17 02:49:54 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7027757
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2264277-scx_c_schedulers/fedora-rawhide-x86_64/07027757-scx_c_schedulers/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 10 Jordan Rome 2024-02-17 20:10:19 UTC
[fedora-review-service-build]

Comment 11 Fedora Review Service 2024-02-18 08:55:17 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7030854
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2264277-scx_c_schedulers/fedora-rawhide-x86_64/07030854-scx_c_schedulers/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 12 Benson Muite 2024-02-25 11:26:38 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[-]: Provides: bundled(gnulib) in place as required.
     Note: Sources not installed
[x]: Package does not contain kernel modules.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[ ]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "GNU General Public License, Version
     2", "BSD 2-Clause License", "GNU Lesser General Public License,
     Version 2.1", "*No copyright* GNU General Public License, Version 2",
     "*No copyright* BSD 2-Clause License", "*No copyright* GNU Lesser
     General Public License, Version 2.1". 231 files have unknown license.
     Detailed output of licensecheck in
     /home/fedora/2264277-scx_c_schedulers/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
[ ]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[ ]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[ ]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 16298 bytes in 1 files.
[ ]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Rpmlint
-------
Checking: scx_c_schedulers-0.1.7-1.fc41.aarch64.rpm
          scx_c_schedulers-debuginfo-0.1.7-1.fc41.aarch64.rpm
          scx_c_schedulers-debugsource-0.1.7-1.fc41.aarch64.rpm
          scx_c_schedulers-0.1.7-1.fc41.src.rpm
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpja927uou')]
checks: 32, packages: 4

scx_c_schedulers.aarch64: W: summary-not-capitalized sched_ext schedulers written in c
scx_c_schedulers.src: W: summary-not-capitalized sched_ext schedulers written in c
scx_c_schedulers.aarch64: E: spelling-error ('flatcg', '%description -l en_US flatcg -> flat cg, flat-cg, flatcar')
scx_c_schedulers.aarch64: E: spelling-error ('qmap', '%description -l en_US qmap -> map, q map')
scx_c_schedulers.aarch64: E: spelling-error ('userland', '%description -l en_US userland -> user land, user-land, slanderous')
scx_c_schedulers.src: E: spelling-error ('flatcg', '%description -l en_US flatcg -> flat cg, flat-cg, flatcar')
scx_c_schedulers.src: E: spelling-error ('qmap', '%description -l en_US qmap -> map, q map')
scx_c_schedulers.src: E: spelling-error ('userland', '%description -l en_US userland -> user land, user-land, slanderous')
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_central
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_flatcg
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_nest
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_pair
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_qmap
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_simple
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_userland
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_central
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_flatcg
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_nest
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_pair
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_qmap
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_simple
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_userland
scx_c_schedulers.aarch64: W: invalid-license LGPL-2.1
scx_c_schedulers.src: W: invalid-license LGPL-2.1
scx_c_schedulers-debuginfo.aarch64: W: invalid-license LGPL-2.1
scx_c_schedulers-debugsource.aarch64: W: invalid-license LGPL-2.1
scx_c_schedulers-debugsource.aarch64: E: files-duplicated-waste 100043
 4 packages and 0 specfiles checked; 7 errors, 20 warnings, 49 filtered, 7 badness; has taken 1.5 s 




Rpmlint (debuginfo)
-------------------
Checking: scx_c_schedulers-debuginfo-0.1.7-1.fc41.aarch64.rpm
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpeyl6auae')]
checks: 32, packages: 1

scx_c_schedulers-debuginfo.aarch64: W: invalid-license LGPL-2.1
 1 packages and 0 specfiles checked; 0 errors, 1 warnings, 35 filtered, 0 badness; has taken 0.5 s 





Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 3

scx_c_schedulers.aarch64: W: summary-not-capitalized sched_ext schedulers written in c
scx_c_schedulers.aarch64: E: spelling-error ('flatcg', '%description -l en_US flatcg -> flat cg, flat-cg, flatcar')
scx_c_schedulers.aarch64: E: spelling-error ('qmap', '%description -l en_US qmap -> map, q map')
scx_c_schedulers.aarch64: E: spelling-error ('userland', '%description -l en_US userland -> user land, user-land, slanderous')
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_central
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_flatcg
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_nest
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_pair
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_qmap
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_simple
scx_c_schedulers.aarch64: W: position-independent-executable-suggested /usr/bin/scx_userland
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_central
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_flatcg
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_nest
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_pair
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_qmap
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_simple
scx_c_schedulers.aarch64: W: no-manual-page-for-binary scx_userland
scx_c_schedulers.aarch64: W: invalid-license LGPL-2.1
scx_c_schedulers-debuginfo.aarch64: W: invalid-license LGPL-2.1
scx_c_schedulers-debugsource.aarch64: W: invalid-license LGPL-2.1
scx_c_schedulers-debugsource.aarch64: E: files-duplicated-waste 100043
 3 packages and 0 specfiles checked; 4 errors, 18 warnings, 45 filtered, 4 badness; has taken 2.3 s 



Source checksums
----------------
https://github.com/libbpf/libbpf/archive/528cb9d3e933c2b10b152249779c2ff72efa4224/libbpf-1.4.0~^20240125git528cb9d.tar.gz :
  CHECKSUM(SHA256) this package     : 45041039893a844772e700769c2f8adbe20b1fcfbd3520516f6768ebf69dc66a
  CHECKSUM(SHA256) upstream package : 45041039893a844772e700769c2f8adbe20b1fcfbd3520516f6768ebf69dc66a
https://github.com/libbpf/bpftool/archive/e17d6cf646e1b3107424386a62afc15a36b18f10/bpftool-7.2.0^20230926gite17d6cf.tar.gz :
  CHECKSUM(SHA256) this package     : 3c6cf4f072431c640217c34cfd90b0b7374fcbafa06db9072a84147a7667951e
  CHECKSUM(SHA256) upstream package : 3c6cf4f072431c640217c34cfd90b0b7374fcbafa06db9072a84147a7667951e
https://github.com/sched-ext/scx/archive/v0.1.7/scx-0.1.7.tar.gz :
  CHECKSUM(SHA256) this package     : 2f1e0c04b88fae1aa3cbf6cd84a57024fd878c48da49f2abe503e7494272e1cb
  CHECKSUM(SHA256) upstream package : 2f1e0c04b88fae1aa3cbf6cd84a57024fd878c48da49f2abe503e7494272e1cb


Requires
--------
scx_c_schedulers (rpmlib, GLIBC filtered):
    ld-linux-aarch64.so.1()(64bit)
    libc.so.6()(64bit)
    libelf.so.1()(64bit)
    libelf.so.1(ELFUTILS_1.0)(64bit)
    libelf.so.1(ELFUTILS_1.3)(64bit)
    libelf.so.1(ELFUTILS_1.5)(64bit)
    libelf.so.1(ELFUTILS_1.6)(64bit)
    libz.so.1()(64bit)
    libz.so.1(ZLIB_1.2.3.3)(64bit)
    rtld(GNU_HASH)

scx_c_schedulers-debuginfo (rpmlib, GLIBC filtered):

scx_c_schedulers-debugsource (rpmlib, GLIBC filtered):



Provides
--------
scx_c_schedulers:
    bundled(bpftool)
    bundled(libbpf)
    scx_c_schedulers
    scx_c_schedulers(aarch-64)

scx_c_schedulers-debuginfo:
    debuginfo(build-id)
    scx_c_schedulers-debuginfo
    scx_c_schedulers-debuginfo(aarch-64)

scx_c_schedulers-debugsource:
    scx_c_schedulers-debugsource
    scx_c_schedulers-debugsource(aarch-64)



Diff spec file in url and in SRPM
---------------------------------
--- /home/fedora/2264277-scx_c_schedulers/srpm/scx_c_schedulers.spec    2024-02-25 06:21:53.481289934 +0000
+++ /home/fedora/2264277-scx_c_schedulers/srpm-unpacked/scx_c_schedulers.spec   2024-02-16 00:00:00.000000000 +0000
@@ -1,2 +1,12 @@
+## START: Set by rpmautospec
+## (rpmautospec version 0.6.1)
+## RPMAUTOSPEC: autorelease, autochangelog
+%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
+    release_number = 1;
+    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
+    print(release_number + base_release_number - 1);
+}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
+## END: Set by rpmautospec
+
 %global toolchain clang
 
@@ -22,5 +32,5 @@
 # bundled libbpf: LGPL-2.1-only OR BSD-2-Clause
 # bpftool: GPL-2.0-only OR BSD-2-Clause
-License:        GPL-2.0-only AND (GPL-2.0-only OR BSD-2-Clause) AND (LGPL-2.1-only OR BSD-2-Clause)
+License:        GPL-2.0-only AND (GPL-2.0-only OR BSD-2-Clause) AND (LGPL-2.1 OR BSD-2-Clause)
 URL:            https://github.com/sched-ext/scx
  
@@ -87,3 +97,6 @@
  
 %changelog
-%autochangelog
+## START: Generated by rpmautospec
+* Fri Feb 16 2024 John Doe <packager> - 0.1.7-1
+- Uncommitted changes
+## END: Generated by rpmautospec


Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/usr/bin/fedora-review -b 2264277
Buildroot used: fedora-rawhide-aarch64
Active plugins: Shell-api, Generic, C/C++
Disabled plugins: Ocaml, R, Java, fonts, Python, PHP, SugarActivity, Perl, Haskell
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH


Comments:
a) Is it possible to add a patch so that Cargo is not required. Probably affects:
https://github.com/sched-ext/scx/blob/main/meson.build#L23
https://github.com/sched-ext/scx/blob/main/meson.build#L110-L155
b) The spec file packaged with the rpm has LGPL-2.1 instead of LGPL-2.1-only
c) Not directly related to this review, but might a bpf SIG be a reasonable thing to have
to update all bpf packages at once so that bundling is reduced?
d) Should BREAKING_CHANGES.md and OVERVIEW.md also be packaged?
e) Is it possible to run a smoke check for each binary, for example ./scx_simple -h
f) Helpful to list all the binaries, though a preference not a requirement
g) Using %exclude is not recommended, better to patch out or use sed to remove:
https://github.com/sched-ext/scx/blob/main/meson.build#L170-L174

Comment 13 Jordan Rome 2024-04-11 00:27:52 UTC
[fedora-review-service-build]

Comment 14 Jordan Rome 2024-04-11 20:00:48 UTC
[fedora-review-service-build]

Comment 15 Neal Gompa 2024-04-12 11:08:07 UTC
The bot is broken now, I think.

Comment 16 Jordan Rome 2024-04-12 16:39:39 UTC
@ngompa13 - Do you mean globally or just for this review? Should I just re-submit a new one?

Comment 17 Neal Gompa 2024-04-13 10:32:50 UTC
It's globally broken. You are going to need to run fedora-review locally for now.

Comment 18 Jordan Rome 2024-04-14 21:32:44 UTC
Created a new review here: https://bugzilla.redhat.com/show_bug.cgi?id=2275018

Comment 19 Neal Gompa 2024-04-14 23:52:09 UTC
You don't need to create a new review. It doesn't change anything. It just means people need to do things manually/locally.

Comment 20 Jordan Rome 2024-04-15 00:19:46 UTC
Okey dokey. So how should I proceed here? Close the other review?

Comment 21 Jordan Rome 2024-04-16 15:45:05 UTC
*** Bug 2275018 has been marked as a duplicate of this bug. ***

Comment 22 Michel Lind 2024-04-18 21:15:29 UTC
Hi Benson,

Hope these notes might address some of the points you raised. Looks like Jordan already addressed most of the rest.

> Comments:
> a) Is it possible to add a patch so that Cargo is not required. Probably
> affects:
> https://github.com/sched-ext/scx/blob/main/meson.build#L23
> https://github.com/sched-ext/scx/blob/main/meson.build#L110-L155

Cargo is not required in this build; there is a separate https://crates.io/crates/scx_utils for the Rust component. The meson build script just supports building all of them together but the Cargo dependency is optional

> b) The spec file packaged with the rpm has LGPL-2.1 instead of LGPL-2.1-only
the bundled libbpf ships that file: https://github.com/libbpf/libbpf/blob/6d3595d215b014d3eddb88038d686e1c20781534/LICENSE.LGPL-2.1

and per https://spdx.org/licenses/LGPL-2.1.html that translates to LGPL 2.1 only (which is LGPL-2.1-only in the new SPDX version,
see https://docs.fedoraproject.org/en-US/legal/allowed-licenses/)

Comment 23 Jordan Rome 2024-04-28 22:33:02 UTC
@benson_muite Gentle ping for a re-review. Thanks!

Comment 24 Michel Lind 2024-05-02 19:57:03 UTC
This seems mostly good. Two issues (one needs to be fixed now, one can be fixed later on import - but since you're reiterating might as well do it now)

must: bpftool ships a LICENSE.GPL-2.0 - the license is no longer identical with libbpf so you need to ship this separately

nice to have: you have a .rpmlintrc file, but there is a spelling warning about the summary not being capitalized. In this case it's the tool's name so is a false positive, you should suppress it

addFilter("W: summary-not-capitalized")

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[-]: Provides: bundled(gnulib) in place as required.
     Note: Sources not installed
[x]: Package does not contain kernel modules.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "BSD 2-Clause License", "GNU Lesser
     General Public License, Version 2.1", "*No copyright* BSD 2-Clause
     License", "GNU General Public License, Version 2", "*No copyright* GNU
     General Public License, Version 2", "*No copyright* Creative Commons
     Attribution 4.0", "*No copyright* GNU Lesser General Public License,
     Version 2.1". 261 files have unknown license. Detailed output of
     licensecheck in
     /home/michel/src/fedora/reviews/2264277-scx_c_schedulers/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
     bpftool has a LICENSE.GPL-2.0 that is not shipped

❯ tar tf bpftool-7.2.0^20230926git20ce693.tar.gz | grep LIC
bpftool-20ce6933869b70bacfdd0dd1a8399199290bf8ff/LICENSE
bpftool-20ce6933869b70bacfdd0dd1a8399199290bf8ff/LICENSE.BSD-2-Clause
bpftool-20ce6933869b70bacfdd0dd1a8399199290bf8ff/LICENSE.GPL-2.0

[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 47634 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: scx_c_schedulers-0.1.8-1.fc41.x86_64.rpm
          scx_c_schedulers-debuginfo-0.1.8-1.fc41.x86_64.rpm
          scx_c_schedulers-debugsource-0.1.8-1.fc41.x86_64.rpm
          scx_c_schedulers-0.1.8-1.fc41.src.rpm
========================================== rpmlint session starts =========================================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmp1aykqhu5')]
checks: 32, packages: 4

scx_c_schedulers.src: W: summary-not-capitalized sched_ext schedulers written in c
scx_c_schedulers.x86_64: W: summary-not-capitalized sched_ext schedulers written in c
scx_c_schedulers.src: E: spelling-error ('flatcg', '%description -l en_US flatcg -> flat cg, flat-cg, flatcar')
scx_c_schedulers.src: E: spelling-error ('qmap', '%description -l en_US qmap -> map, q map')
scx_c_schedulers.src: E: spelling-error ('userland', '%description -l en_US userland -> user land, user-land, slanderous')
scx_c_schedulers.x86_64: E: spelling-error ('flatcg', '%description -l en_US flatcg -> flat cg, flat-cg, flatcar')
scx_c_schedulers.x86_64: E: spelling-error ('qmap', '%description -l en_US qmap -> map, q map')
scx_c_schedulers.x86_64: E: spelling-error ('userland', '%description -l en_US userland -> user land, user-land, slanderous')
scx_c_schedulers.x86_64: W: position-independent-executable-suggested /usr/bin/scx_central
scx_c_schedulers.x86_64: W: position-independent-executable-suggested /usr/bin/scx_flatcg
scx_c_schedulers.x86_64: W: position-independent-executable-suggested /usr/bin/scx_nest
scx_c_schedulers.x86_64: W: position-independent-executable-suggested /usr/bin/scx_pair
scx_c_schedulers.x86_64: W: position-independent-executable-suggested /usr/bin/scx_qmap
scx_c_schedulers.x86_64: W: position-independent-executable-suggested /usr/bin/scx_simple
scx_c_schedulers.x86_64: W: position-independent-executable-suggested /usr/bin/scx_userland
scx_c_schedulers.x86_64: W: no-manual-page-for-binary scx_central
scx_c_schedulers.x86_64: W: no-manual-page-for-binary scx_flatcg
scx_c_schedulers.x86_64: W: no-manual-page-for-binary scx_nest
scx_c_schedulers.x86_64: W: no-manual-page-for-binary scx_pair
scx_c_schedulers.x86_64: W: no-manual-page-for-binary scx_qmap
scx_c_schedulers.x86_64: W: no-manual-page-for-binary scx_simple
scx_c_schedulers.x86_64: W: no-manual-page-for-binary scx_userland
scx_c_schedulers-debugsource.x86_64: E: files-duplicated-waste 122801
==== 4 packages and 0 specfiles checked; 7 errors, 16 warnings, 46 filtered, 7 badness; has taken 1.5 s ===




Rpmlint (debuginfo)
-------------------
Checking: scx_c_schedulers-debuginfo-0.1.8-1.fc41.x86_64.rpm
========================================== rpmlint session starts =========================================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpqmw6f2ef')]
checks: 32, packages: 1

==== 1 packages and 0 specfiles checked; 0 errors, 0 warnings, 31 filtered, 0 badness; has taken 0.6 s ====





Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 3

scx_c_schedulers.x86_64: W: summary-not-capitalized sched_ext schedulers written in c
scx_c_schedulers.x86_64: E: spelling-error ('flatcg', '%description -l en_US flatcg -> flat cg, flat-cg, flatcar')
scx_c_schedulers.x86_64: E: spelling-error ('qmap', '%description -l en_US qmap -> map, q map')
scx_c_schedulers.x86_64: E: spelling-error ('userland', '%description -l en_US userland -> user land, user-land, slanderous')
scx_c_schedulers.x86_64: W: position-independent-executable-suggested /usr/bin/scx_central
scx_c_schedulers.x86_64: W: position-independent-executable-suggested /usr/bin/scx_flatcg
scx_c_schedulers.x86_64: W: position-independent-executable-suggested /usr/bin/scx_nest
scx_c_schedulers.x86_64: W: position-independent-executable-suggested /usr/bin/scx_pair
scx_c_schedulers.x86_64: W: position-independent-executable-suggested /usr/bin/scx_qmap
scx_c_schedulers.x86_64: W: position-independent-executable-suggested /usr/bin/scx_simple
scx_c_schedulers.x86_64: W: position-independent-executable-suggested /usr/bin/scx_userland
scx_c_schedulers.x86_64: W: no-manual-page-for-binary scx_central
scx_c_schedulers.x86_64: W: no-manual-page-for-binary scx_flatcg
scx_c_schedulers.x86_64: W: no-manual-page-for-binary scx_nest
scx_c_schedulers.x86_64: W: no-manual-page-for-binary scx_pair
scx_c_schedulers.x86_64: W: no-manual-page-for-binary scx_qmap
scx_c_schedulers.x86_64: W: no-manual-page-for-binary scx_simple
scx_c_schedulers.x86_64: W: no-manual-page-for-binary scx_userland
scx_c_schedulers-debugsource.x86_64: E: files-duplicated-waste 122801
 3 packages and 0 specfiles checked; 4 errors, 15 warnings, 42 filtered, 4 badness; has taken 3.3 s 



Source checksums
----------------
https://github.com/libbpf/libbpf/archive/6d3595d215b014d3eddb88038d686e1c20781534/libbpf-1.4.0~^20240125git6d3595d.tar.gz :
  CHECKSUM(SHA256) this package     : 423f1392f1f14226a295b1be68ba14da12d25e86f20c754aed4afeef74bdee7c
  CHECKSUM(SHA256) upstream package : 423f1392f1f14226a295b1be68ba14da12d25e86f20c754aed4afeef74bdee7c
https://github.com/libbpf/bpftool/archive/20ce6933869b70bacfdd0dd1a8399199290bf8ff/bpftool-7.2.0^20230926git20ce693.tar.gz :
  CHECKSUM(SHA256) this package     : 3eaa3afc4e8d1109a88d7e138657c6144fb8901af1c3505663208f25538ba426
  CHECKSUM(SHA256) upstream package : 3eaa3afc4e8d1109a88d7e138657c6144fb8901af1c3505663208f25538ba426
https://github.com/sched-ext/scx/archive/v0.1.8/scx-0.1.8.tar.gz :
  CHECKSUM(SHA256) this package     : 4e7eac237d71452412401b8bc637b3338610244223b701a65507aeee8e68d2eb
  CHECKSUM(SHA256) upstream package : 4e7eac237d71452412401b8bc637b3338610244223b701a65507aeee8e68d2eb


Requires
--------
scx_c_schedulers (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libelf.so.1()(64bit)
    libelf.so.1(ELFUTILS_1.0)(64bit)
    libelf.so.1(ELFUTILS_1.3)(64bit)
    libelf.so.1(ELFUTILS_1.5)(64bit)
    libelf.so.1(ELFUTILS_1.6)(64bit)
    libz.so.1()(64bit)
    libz.so.1(ZLIB_1.2.3.3)(64bit)
    rtld(GNU_HASH)

scx_c_schedulers-debuginfo (rpmlib, GLIBC filtered):

scx_c_schedulers-debugsource (rpmlib, GLIBC filtered):



Provides
--------
scx_c_schedulers:
    bundled(bpftool)
    bundled(libbpf)
    scx_c_schedulers
    scx_c_schedulers(x86-64)

scx_c_schedulers-debuginfo:
    debuginfo(build-id)
    scx_c_schedulers-debuginfo
    scx_c_schedulers-debuginfo(x86-64)

scx_c_schedulers-debugsource:
    scx_c_schedulers-debugsource
    scx_c_schedulers-debugsource(x86-64)



Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/usr/bin/fedora-review -b 2264277
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, C/C++, Generic
Disabled plugins: SugarActivity, fonts, R, Haskell, Java, PHP, Ocaml, Python, Perl
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH

Comment 25 Jordan Rome 2024-05-04 01:10:49 UTC
@michel Thanks for the review. I updated the rpmlintrc with your suggestion and added this line to the spec file for bpftool license `mv bpftool/LICENSE.GPL-2.0 bpftool-LICENSE.GPL-2.0`

Comment 26 Jordan Rome 2024-05-04 01:12:16 UTC
Oh and I updated this line in the spec file `%license %{scx_dir}/LICENSE libbpf-LICENSE* bpftool-LICENSE*`

Comment 27 Michel Lind 2024-05-07 20:08:39 UTC
LGTM, approved

Comment 28 Fedora Admin user for bugzilla script actions 2024-05-07 21:17:03 UTC
The Pagure repository was created at https://src.fedoraproject.org/rpms/scx_c_schedulers


Note You need to log in before you can comment on or make changes to this bug.